Index: XIOS/dev/dev_olga/src/attribute_map.cpp
===================================================================
--- XIOS/dev/dev_olga/src/attribute_map.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/attribute_map.cpp	(revision 1009)
@@ -28,9 +28,4 @@
 
       //---------------------------------------------------------------
-
-      bool CAttributeMap::hasAttribute(const StdString& key) const
-      {
-         return (this->find(key) != this->end());
-      }
 
       void CAttributeMap::clearAttribute(const StdString& key)
Index: XIOS/dev/dev_olga/src/attribute_map.hpp
===================================================================
--- XIOS/dev/dev_olga/src/attribute_map.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/attribute_map.hpp	(revision 1009)
@@ -20,5 +20,5 @@
 
             /// Tests ///
-            inline bool hasAttribute(const StdString & key) const;
+            bool hasAttribute(const StdString & key) const;
 
             /// Accesseurs ///
@@ -72,4 +72,9 @@
       };  // class CAttributeMap
 
+      inline bool CAttributeMap::hasAttribute(const StdString& key) const
+      {
+        return (this->find(key) != this->end());
+      }
+
 } // namespace xios
 
Index: XIOS/dev/dev_olga/src/client.cpp
===================================================================
--- XIOS/dev/dev_olga/src/client.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/client.cpp	(revision 1009)
@@ -18,5 +18,5 @@
     MPI_Comm CClient::interComm ;
     std::list<MPI_Comm> CClient::contextInterComms;
-    int CClient::serverLeader;
+    vector <int> CClient::serverLeader;
     bool CClient::is_MPI_Initialized ;
     int CClient::rank = INVALID_RANK;
@@ -103,11 +103,15 @@
           {
             int clientLeader=leaders[hashClient] ;
-            serverLeader=leaders[hashServer] ;
+//            serverLeader=leaders[hashServer] ;
+            serverLeader.push_back(leaders[hashServer]) ;
             int intraCommSize, intraCommRank ;
             MPI_Comm_size(intraComm,&intraCommSize) ;
             MPI_Comm_rank(intraComm,&intraCommRank) ;
             info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
-                   <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
-             MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
+                   <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader.back()<<endl ;
+             MPI_Intercomm_create(intraComm, 0, CXios::globalComm, serverLeader.back(), 0, &interComm) ;
+//             info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
+//                    <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
+//              MPI_Intercomm_create(intraComm,0,CXios::globalComm,serverLeader,0,&interComm) ;
           }
           else
@@ -161,15 +165,16 @@
     }
 
-    void CClient::initializeClientOnServer(const int rank, MPI_Comm& intraCommPrmSrv, const int srvSndLeader)
+    void CClient::initializeClientOnServer(const int rank, const MPI_Comm& intraCommPrmSrv, const int srvSndLeader)
     {
       MPI_Comm_dup(intraCommPrmSrv, &intraComm) ;
-      serverLeader = srvSndLeader;
+      serverLeader.push_back(srvSndLeader);
       int intraCommSize, intraCommRank ;
       MPI_Comm_size(intraComm,&intraCommSize) ;
       MPI_Comm_rank(intraComm,&intraCommRank) ;
       info(50)<<"intercommCreate::client "<<rank<<" intraCommSize : "<<intraCommSize
-          <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< serverLeader<<endl ;
-      MPI_Intercomm_create(intraComm, 0, CXios::globalComm, serverLeader, 0, &interComm) ;
-    }
+          <<" intraCommRank :"<<intraCommRank<<"  clientLeader "<< srvSndLeader<<endl ;
+      MPI_Intercomm_create(intraComm, 0, CXios::globalComm, srvSndLeader, 0, &interComm) ;
+    }
+
 
 ///---------------------------------------------------------------
@@ -226,20 +231,75 @@
         buffer<<msg ;
 
-        MPI_Send(buff, buffer.count(), MPI_CHAR, serverLeader, 1, CXios::globalComm) ;
+        for (int i = 0; i < serverLeader.size(); ++i)
+        {
+          MPI_Send(buff, buffer.count(), MPI_CHAR, serverLeader[i], 1, CXios::globalComm) ;
+          MPI_Intercomm_create(contextComm, 0, CXios::globalComm, serverLeader[i], 10+globalRank, &contextInterComm) ;
+          info(10)<<"Register new Context : "<<id<<endl ;
+          MPI_Comm inter ;
+          MPI_Intercomm_merge(contextInterComm,0,&inter) ;
+          MPI_Barrier(inter) ;
+
+          context->initClient(contextComm,contextInterComm) ;
+
+          contextInterComms.push_back(contextInterComm);
+          MPI_Comm_free(&inter);
+        }
         delete [] buff ;
 
-        MPI_Intercomm_create(contextComm, 0, CXios::globalComm, serverLeader, 10+globalRank, &contextInterComm) ;
-        info(10)<<"Register new Context : "<<id<<endl ;
-
-        MPI_Comm inter ;
-        MPI_Intercomm_merge(contextInterComm,0,&inter) ;
-        MPI_Barrier(inter) ;
-
-        context->initClient(contextComm,contextInterComm) ;
-
-        contextInterComms.push_back(contextInterComm);
-        MPI_Comm_free(&inter);
-      }
-    }
+      }
+    }
+
+    ///---------------------------------------------------------------
+    /*!
+     * \fn void CClient::registerContext(const string& id, const int poolNb, MPI_Comm contextComm)
+     * Function creates intraComm (CClient::intraComm) for client group with id=codeId and interComm (CClient::interComm) between client and server groups.
+     * \param [in] id id of context.
+     * \param [in] contextComm.
+     */
+        void CClient::registerContextOnSrvPools(const string& id, MPI_Comm contextComm)
+        {
+          CContext::setCurrent(id) ;
+          CContext* context=CContext::create(id);
+          StdString idServer(id);
+          idServer += "_server_";
+
+          int size,rank,globalRank ;
+          size_t message_size ;
+          int leaderRank ;
+          MPI_Comm contextInterComm ;
+
+          MPI_Comm_size(contextComm,&size) ;
+          MPI_Comm_rank(contextComm,&rank) ;
+          MPI_Comm_rank(CXios::globalComm,&globalRank) ;
+          if (rank!=0) globalRank=0 ;
+
+          CMessage msg ;
+
+          int messageSize ;
+          void * buff ;
+
+          for (int i = 0; i < serverLeader.size(); ++i)
+          {
+            StdString str = idServer + boost::lexical_cast<string>(i);
+            msg<<str<<size<<globalRank ;
+            messageSize = msg.size() ;
+            buff = new char[messageSize] ;
+            CBufferOut buffer(buff,messageSize) ;
+            buffer<<msg ;
+
+            MPI_Send(buff, buffer.count(), MPI_CHAR, serverLeader[i], 1, CXios::globalComm) ;
+            MPI_Intercomm_create(contextComm, 0, CXios::globalComm, serverLeader[i], 10+globalRank, &contextInterComm) ;
+            info(10)<<"Register new Context : "<<id<<endl ;
+            MPI_Comm inter ;
+            MPI_Intercomm_merge(contextInterComm,0,&inter) ;
+            MPI_Barrier(inter) ;
+
+            context->initClient(contextComm,contextInterComm) ;
+
+            contextInterComms.push_back(contextInterComm);
+            MPI_Comm_free(&inter);
+            delete [] buff ;
+          }
+        }
 
     void CClient::finalize(void)
Index: XIOS/dev/dev_olga/src/client.hpp
===================================================================
--- XIOS/dev/dev_olga/src/client.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/client.hpp	(revision 1009)
@@ -11,12 +11,14 @@
       public:
         static void initialize(const string& codeId, MPI_Comm& localComm, MPI_Comm& returnComm);
-        static void initializeClientOnServer(const int rank, MPI_Comm& localComm, const int srvSndLeader);
+        static void initializeClientOnServer(const int rank, const MPI_Comm& localComm, const int srvSndLeader);
+
         static void finalize(void);
         static void registerContext(const string& id, MPI_Comm contextComm);
+        static void registerContextOnSrvPools(const string& id, MPI_Comm contextComm);
 
         static MPI_Comm intraComm;
         static MPI_Comm interComm;
         static std::list<MPI_Comm> contextInterComms;
-        static int serverLeader;
+        static vector<int> serverLeader;
         static bool is_MPI_Initialized ;
 
Index: XIOS/dev/dev_olga/src/context_server.cpp
===================================================================
--- XIOS/dev/dev_olga/src/context_server.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/context_server.cpp	(revision 1009)
@@ -62,5 +62,4 @@
     boost::hash<string> hashString;
     StdString contextId = context->getId();
-    contextId += "_prim";                      // just to distinguish between server and serverPrimServer on server1
     hashId=hashString(contextId);
 
Index: XIOS/dev/dev_olga/src/group_template.hpp
===================================================================
--- XIOS/dev/dev_olga/src/group_template.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/group_template.hpp	(revision 1009)
@@ -72,4 +72,5 @@
          static bool dispatchEvent(CEventServer& event) ;
          void sendCreateChild(const string& id="") ;
+         void sendCreateChild(const string& id, const int srvPool) ;
          void sendCreateChildGroup(const string& id="") ;
          static void recvCreateChild(CEventServer& event) ;
Index: XIOS/dev/dev_olga/src/group_template_impl.hpp
===================================================================
--- XIOS/dev/dev_olga/src/group_template_impl.hpp	(revision 992)
+++ XIOS/dev/dev_olga/src/group_template_impl.hpp	(revision 1009)
@@ -379,18 +379,23 @@
     {
       // Use correct context client to send message
-       CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
-
-       CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;   
-       if (contextClientTmp->isServerLeader())
-       {
-         CMessage msg ;
-         msg<<this->getId() ;
-         msg<<id ;
-         const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
-         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-           event.push(*itRank,1,msg) ;
-         contextClientTmp->sendEvent(event) ;
-       }
-       else contextClientTmp->sendEvent(event) ;
+//      CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+      int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+      for (int i = 0; i < nbSrvPools; ++i)
+      {
+         CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i] : context->client;
+
+         CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;
+         if (contextClientTmp->isServerLeader())
+         {
+           CMessage msg ;
+           msg<<this->getId() ;
+           msg<<id ;
+           const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+           for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+             event.push(*itRank,1,msg) ;
+           contextClientTmp->sendEvent(event) ;
+         }
+         else contextClientTmp->sendEvent(event) ;
+      }
     }
 
@@ -416,4 +421,24 @@
    
    template <class U, class V, class W>
+   void CGroupTemplate<U, V, W>::sendCreateChild(const string& id, const int srvPool)
+   {
+    CContext* context=CContext::getCurrent() ;
+    CContextClient* contextClientTmp = context->clientPrimServer[srvPool];
+
+    CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD) ;
+    if (contextClientTmp->isServerLeader())
+    {
+      CMessage msg ;
+      msg<<this->getId() ;
+      msg<<id ;
+      const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+       event.push(*itRank,1,msg) ;
+      contextClientTmp->sendEvent(event) ;
+    }
+    else contextClientTmp->sendEvent(event) ;
+   }
+
+   template <class U, class V, class W>
    void CGroupTemplate<U, V, W>::sendCreateChildGroup(const string& id)
    {
@@ -424,18 +449,22 @@
     {
         // Use correct context client to send message
-       CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
-
-       CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;   
-       if (contextClientTmp->isServerLeader())
-       {
-         CMessage msg ;
-         msg<<this->getId() ;
-         msg<<id ;
-         const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
-         for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-           event.push(*itRank,1,msg) ;
-         contextClientTmp->sendEvent(event) ;
-       }
-       else contextClientTmp->sendEvent(event) ;
+//      CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer : context->client;
+      int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+      for (int i = 0; i < nbSrvPools; ++i)
+      {
+        CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i] : context->client;
+        CEventClient event(this->getType(),EVENT_ID_CREATE_CHILD_GROUP) ;
+        if (contextClientTmp->isServerLeader())
+        {
+          CMessage msg ;
+          msg<<this->getId() ;
+          msg<<id ;
+          const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+          for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+            event.push(*itRank,1,msg) ;
+          contextClientTmp->sendEvent(event) ;
+        }
+        else contextClientTmp->sendEvent(event) ;
+      }
     }
 
Index: XIOS/dev/dev_olga/src/node/axis.cpp
===================================================================
--- XIOS/dev/dev_olga/src/node/axis.cpp	(revision 992)
+++ XIOS/dev/dev_olga/src/node/axis.cpp	(revision 1009)
@@ -889,47 +889,48 @@
   {
     CContext* context = CContext::getCurrent();
-
-    CContextClient* contextClientTmp = (0 != context->clientPrimServer) ? context->clientPrimServer 
-                                                                        : context->client;
-
-    
-    int nbServer = contextClientTmp->serverSize;
-
-    CServerDistributionDescription serverDescription(globalDim, nbServer);
-    serverDescription.computeServerDistribution();
-
-    std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
-    std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
-
-    globalDimGrid.resize(globalDim.size());
-    for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
-
-    CEventClient event(getType(),EVENT_ID_SERVER_ATTRIBUT);
-    if (contextClientTmp->isServerLeader())
-    {
-      std::list<CMessage> msgs;
-
-      const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
-      for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-      {
-        // Use const int to ensure CMessage holds a copy of the value instead of just a reference
-        const int begin = serverIndexBegin[*itRank][orderPositionInGrid];
-        const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
-        const int end   = begin + ni - 1;
-
-        msgs.push_back(CMessage());
-        CMessage& msg = msgs.back();
-        msg << this->getId();
-        msg << ni << begin << end;
-        msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
-        msg << isCompressible_;
-        msg << orderPositionInGrid;
-        msg << globalDimGrid;
-
-        event.push(*itRank,1,msg);
-      }
-      contextClientTmp->sendEvent(event);
-    }
-    else contextClientTmp->sendEvent(event);
+    int nbSrvPools = (context->hasServer) ? context->clientPrimServer.size() : 1;
+    for (int i = 0; i < nbSrvPools; ++i)
+    {
+      CContextClient* contextClientTmp = (context->hasServer) ? context->clientPrimServer[i]
+                                                                          : context->client;
+      int nbServer = contextClientTmp->serverSize;
+
+      CServerDistributionDescription serverDescription(globalDim, nbServer);
+      serverDescription.computeServerDistribution();
+
+      std::vector<std::vector<int> > serverIndexBegin = serverDescription.getServerIndexBegin();
+      std::vector<std::vector<int> > serverDimensionSizes = serverDescription.getServerDimensionSizes();
+
+      globalDimGrid.resize(globalDim.size());
+      for (int idx = 0; idx < globalDim.size(); ++idx) globalDimGrid(idx) = globalDim[idx];
+
+      CEventClient event(getType(),EVENT_ID_SERVER_ATTRIBUT);
+      if (contextClientTmp->isServerLeader())
+      {
+        std::list<CMessage> msgs;
+
+        const std::list<int>& ranks = contextClientTmp->getRanksServerLeader();
+        for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
+        {
+          // Use const int to ensure CMessage holds a copy of the value instead of just a reference
+          const int begin = serverIndexBegin[*itRank][orderPositionInGrid];
+          const int ni    = serverDimensionSizes[*itRank][orderPositionInGrid];
+          const int end   = begin + ni - 1;
+
+          msgs.push_back(CMessage());
+          CMessage& msg = msgs.back();
+          msg << this->getId();
+          msg << ni << begin << end;
+          msg << global_zoom_begin.getValue() << global_zoom_n.getValue();
+          msg << isCompressible_;
+          msg << orderPositionInGrid;
+          msg << globalDimGrid;
+
+          event.push(*itRank,1,msg);
+        }
+        contextClientTmp->sendEvent(event);
+      }
+      else contextClientTmp->sendEvent(event);
+    }
   }
 
